/******************************************************************************/
/* Copyright (C) SEIKO EPSON CORPORATION 2010. All rights reserved.           */
/******************************************************************************/
/*                                                                            */
/* PLQStatusApiPartialInterface.h                                             */
/*                                                                            */
/* Partial interface definition of Status API                                 */
/*                                                                            */
/* Modification history                                                       */
/* -------------------------------------------------------------------------- */
/* 2010-05-14   New                                                           */
/*                                                                            */
/******************************************************************************/

#if !defined(_PLQSTATUSAPIPARTIALINTERFACE_H)
#define _PLQSTATUSAPIPARTIALINTERFACE_H

#include "PLQStatusApiDef.h"

#ifndef __STDCALL__
#if defined(WIN32)
#define __STDCALL__ __stdcall
#elif defined(__GNUC__)
#define __STDCALL__ __attribute__((stdcall))
#endif
#endif


typedef int (__STDCALL__ *DLL_BiOpenMonPrinter)                  (int, EPBS_PCHAR);
typedef int (__STDCALL__ *DLL_BiGetStatus)                       (int, EPBS_PUINT32);
typedef int (__STDCALL__ *DLL_BiGetMultiStatus)                  (int, EPBS_UINT32, EPBS_PUINT32);
typedef int (__STDCALL__ *DLL_BiSetStatusBackFunction)           (int, int(__STDCALL__ *)(EPBS_UINT32));
typedef int (__STDCALL__ *DLL_BiSetStatusBackFunctionEx)         (int, int(__STDCALL__ *)(EPBS_UINT32, EPBS_PCHAR));
typedef int (__STDCALL__ *DLL_BiSetMultiStatusBackFunction)      (int, int(__STDCALL__ *)(EPBS_UINT32, EPBS_UINT32, EPBS_PCHAR));
typedef int (__STDCALL__ *DLL_BiCancelStatusBack)                (int);
typedef int (__STDCALL__ *DLL_BiResetPrinter)                    (int);
typedef int (__STDCALL__ *DLL_BiSCNMICRFunction)                 (int, EPBS_PVOID, EPBS_UINT16);
typedef int (__STDCALL__ *DLL_BiGetPrnCapability)                (int, EPBS_UINT8, EPBS_PUINT8, EPBS_PUINT8);
typedef int (__STDCALL__ *DLL_BiCloseMonPrinter)                 (int);
typedef int (__STDCALL__ *DLL_BiGetVersion)                      (int, int, LPVERSION_INFO);
typedef int (__STDCALL__ *DLL_BiMICRClearSpaces)                 (int, EPBS_UINT8);
typedef int (__STDCALL__ *DLL_BiMSRWSetting)                     (int, LPMF_MSRW);
typedef int (__STDCALL__ *DLL_BiMSRWReadStripeData)              (int, EPBS_UINT32);
typedef int (__STDCALL__ *DLL_BiMSRWGetStripeData)               (int, EPBS_UINT32, EPBS_PUINT8, EPBS_UINT32, EPBS_PUINT32, EPBS_PUINT32);
typedef int (__STDCALL__ *DLL_BiMSRWWriteStripeData)             (int, EPBS_UINT32, EPBS_PUINT8, EPBS_UINT32);
typedef int (__STDCALL__ *DLL_BiMSRWClearStripeData)             (int, EPBS_UINT32);
typedef int (__STDCALL__ *DLL_BiEjectPaper)                      (int, EPBS_UINT16, EPBS_UINT32);
typedef int (__STDCALL__ *DLL_BiLockPort)                        (int, EPBS_UINT32);
typedef int (__STDCALL__ *DLL_BiUnlockPort)                      (int);

#endif  /* !defined(_PLQSTATUSAPIPARTIALINTERFACE_H) */
