// SampleProgramDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SampleProgram.h"
#include "SampleProgramDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSampleProgramDlg dialog


CSampleProgramDlg::CSampleProgramDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSampleProgramDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSampleProgramDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CSampleProgramDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_MICR_READ, &CSampleProgramDlg::OnBnClickedButtonMicrRead)
	ON_CBN_SELCHANGE(IDC_COMBO_FORMAT, &CSampleProgramDlg::OnCbnSelchangeComboFormat)
	ON_BN_CLICKED(IDC_BUTTON_MS_READ, &CSampleProgramDlg::OnBnClickedButtonMsRead)
	ON_BN_CLICKED(IDC_BUTTON_MS_WRITE, &CSampleProgramDlg::OnBnClickedButtonMsWrite)
	ON_BN_CLICKED(IDC_BUTTON_MS_CLEAR, &CSampleProgramDlg::OnBnClickedButtonMsClear)
	ON_BN_CLICKED(IDC_BUTTON_EXIT, &CSampleProgramDlg::OnBnClickedButtonExit)
END_MESSAGE_MAP()


// CSampleProgramDlg message handlers

BOOL CSampleProgramDlg::OnInitDialog(void)
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	((CEdit*)GetDlgItem(IDC_EDIT_MICR))->SetWindowText(NULL);
	((CEdit*)GetDlgItem(IDC_EDIT_READ))->SetWindowText(NULL);
	((CEdit*)GetDlgItem(IDC_EDIT_WRITE))->SetWindowText(NULL);
	((CEdit*)GetDlgItem(IDC_EDIT_WRITE))->LimitText(105);
	((CButton*)GetDlgItem(IDC_CHECK_SAVE_MICR))->SetCheck(FALSE);
	((CButton*)GetDlgItem(IDC_CHECK_SAVE_MSR))->SetCheck(FALSE);
	((CComboBox*)GetDlgItem(IDC_COMBO_FORMAT))->SetCurSel(0);
	CheckRadioButton(IDC_RADIO_MICR, IDC_RADIO_MICROCR, IDC_RADIO_MICR);
	CheckRadioButton(IDC_RADIO_E13B, IDC_RADIO_CMC7, IDC_RADIO_E13B);
	CheckRadioButton(IDC_RADIO_3C, IDC_RADIO_3F, IDC_RADIO_3C);
	EnableButton(TRUE);
	EnableIBMDataType(TRUE);

	// Create PLQ-22 API interface
	if(!m_api.InitInstance())
	{
		// If failed, the program will terminate
		EndDialog(0);
	}
	else
	{
		// Retrieve and display device status information
		GetDeviceStatus();
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSampleProgramDlg::OnPaint(void)
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSampleProgramDlg::OnQueryDragIcon(void)
{
	return static_cast<HCURSOR>(m_hIcon);
}


// Actions taken after MICR Read button pressed
void CSampleProgramDlg::OnBnClickedButtonMicrRead(void)
{
	EPBS_UINT8 bSelect = MF_MICR_USE_MICR | MF_MICR_READ_RETRY;
	EPBS_UINT8 bFont = MF_MICR_FONT_E13B;
	bool bSave = false;

	((CEdit*)GetDlgItem(IDC_EDIT_MICR))->SetWindowText(NULL);
	((CEdit*)GetDlgItem(IDC_EDIT_MICR))->UpdateWindow();
	EnableButton(FALSE);

	if(GetCheckedRadioButton(IDC_RADIO_MICR, IDC_RADIO_MICROCR) == IDC_RADIO_MICROCR)
	{
		bSelect = MF_MICR_USE_MICR | MF_MICR_USE_OCR | MF_MICOCR_READ_RETRY;
	}

	if(GetCheckedRadioButton(IDC_RADIO_E13B, IDC_RADIO_CMC7) == IDC_RADIO_CMC7)
	{
		bFont = MF_MICR_FONT_CMC7;
	}

	if(((CButton*)GetDlgItem(IDC_CHECK_SAVE_MICR))->GetCheck() == BST_CHECKED)
	{
		bSave = true;
	}

	CString strMicr = m_api.ReadMICR(bSelect, bFont, bSave);

	((CEdit*)GetDlgItem(IDC_EDIT_MICR))->SetWindowText(strMicr);

	EnableButton(TRUE);
}

// Actions taken after Format combo box selection changed
void CSampleProgramDlg::OnCbnSelchangeComboFormat(void)
{
	EPBS_UINT32 dwFormat = GetFormat();
	if(dwFormat == EPS_BI_MSRW_FORMAT_IBM3604 || dwFormat == EPS_BI_MSRW_FORMAT_IBM4746)
	{
		EnableIBMDataType(TRUE);
	}
	else
	{
		EnableIBMDataType(FALSE);
	}
}

// Actions taken after MS Read button pressed
void CSampleProgramDlg::OnBnClickedButtonMsRead(void)
{
	EPBS_UINT32 dwFormat = EPS_BI_MSRW_FORMAT_IBM3604;
	EPBS_UINT32 dwDataType = EPS_BI_MSRW_EOM_NONE;
	bool bSave = false;

	((CEdit*)GetDlgItem(IDC_EDIT_READ))->SetWindowText(NULL);
	((CEdit*)GetDlgItem(IDC_EDIT_READ))->UpdateWindow();
	EnableButton(FALSE);

	dwFormat = GetFormat();

	if(dwFormat == EPS_BI_MSRW_FORMAT_IBM3604 || dwFormat == EPS_BI_MSRW_FORMAT_IBM4746)
	{
		if(GetCheckedRadioButton(IDC_RADIO_3C, IDC_RADIO_3F) == IDC_RADIO_3C)
		{
			dwDataType = EPS_BI_MSRW_EOM_3C;
		}
		else
		{
			dwDataType = EPS_BI_MSRW_EOM_3F;
		}
	}

	if(((CButton*)GetDlgItem(IDC_CHECK_SAVE_MSR))->GetCheck() == BST_CHECKED)
	{
		bSave = true;
	}

	CString strMsr = m_api.ReadStripe(dwFormat, dwDataType, bSave);

	((CEdit*)GetDlgItem(IDC_EDIT_READ))->SetWindowText(strMsr);

	EnableButton(TRUE);
}

// Actions taken after MS Write button pressed
void CSampleProgramDlg::OnBnClickedButtonMsWrite(void)
{
	EPBS_UINT32 dwFormat = EPS_BI_MSRW_FORMAT_IBM3604;
	EPBS_UINT32 dwDataType = EPS_BI_MSRW_EOM_NONE;

	if(MessageBox(_T("Click OK to write to magnetic stripe?"), DIALOG_CAPTION, MB_OKCANCEL | MB_ICONQUESTION) == IDCANCEL)
	{
		return;
	}

	CString strMsw;
	strMsw.Empty();
	((CEdit*)GetDlgItem(IDC_EDIT_WRITE))->GetWindowText(strMsw);

	if(CheckWriteString(strMsw))
	{
		return;
	}

	EnableButton(FALSE);

	dwFormat = GetFormat();

	if(dwFormat == EPS_BI_MSRW_FORMAT_IBM3604 || dwFormat == EPS_BI_MSRW_FORMAT_IBM4746)
	{
		if(GetCheckedRadioButton(IDC_RADIO_3C, IDC_RADIO_3F) == IDC_RADIO_3C)
		{
			dwDataType = EPS_BI_MSRW_EOM_3C;
		}
		else
		{
			dwDataType = EPS_BI_MSRW_EOM_3F;
		}
	}

	m_api.WriteStripe(dwFormat, dwDataType, strMsw);

	EnableButton(TRUE);
}

// Actions taken after MS Clear button pressed
void CSampleProgramDlg::OnBnClickedButtonMsClear(void)
{
	EPBS_UINT32 dwFormat = EPS_BI_MSRW_FORMAT_IBM3604;
	EPBS_UINT32 dwDataType = EPS_BI_MSRW_EOM_NONE;

	if(MessageBox(_T("Click OK to erase magnetic stripe?"), DIALOG_CAPTION, MB_OKCANCEL | MB_ICONQUESTION) == IDCANCEL)
	{
		return;
	}

	EnableButton(FALSE);

	dwFormat = GetFormat();

	if(dwFormat == EPS_BI_MSRW_FORMAT_IBM3604 || dwFormat == EPS_BI_MSRW_FORMAT_IBM4746)
	{
		if(GetCheckedRadioButton(IDC_RADIO_3C, IDC_RADIO_3F) == IDC_RADIO_3C)
		{
			dwDataType = EPS_BI_MSRW_EOM_3C;
		}
		else
		{
			dwDataType = EPS_BI_MSRW_EOM_3F;
		}
	}

	m_api.ClearStripe(dwFormat, dwDataType);

	EnableButton(TRUE);
}

// Actions taken after Exit button pressed
void CSampleProgramDlg::OnBnClickedButtonExit(void)
{
	m_api.Exit();
	EndDialog(0);
}

// Populate check boxes in Status area
void CSampleProgramDlg::SetDeviceStatus(EPBS_UINT32 dwStatusType, EPBS_UINT32 dwStatus)
{
	if(dwStatusType == EPS_STATUS_INDEX_GENERAL && dwStatus == ESCMC_ASB_NO_RESPONSE)
	{
		((CButton*)GetDlgItem(IDC_CHECK_NO_RESPONSE))->SetCheck(TRUE);
		((CButton*)GetDlgItem(IDC_CHECK_OFFLINE))->SetCheck(FALSE);
		((CButton*)GetDlgItem(IDC_CHECK_PAPER_FEED))->SetCheck(FALSE);
		((CButton*)GetDlgItem(IDC_CHECK_PAPER_SET))->SetCheck(FALSE);
		((CButton*)GetDlgItem(IDC_CHECK_COVER_STATUS))->SetCheck(FALSE);

		((CButton*)GetDlgItem(IDC_CHECK_NO_PAPER))->SetCheck(FALSE);
		((CButton*)GetDlgItem(IDC_CHECK_PAPER_EJECT))->SetCheck(FALSE);
		((CButton*)GetDlgItem(IDC_CHECK_COVER_OPEN))->SetCheck(FALSE);

		((CButton*)GetDlgItem(IDC_CHECK_FATAL_ERROR))->SetCheck(FALSE);

		((CButton*)GetDlgItem(IDC_CHECK_HEAD_HOT_ERROR))->SetCheck(FALSE);
	}
	else
	{
		((CButton*)GetDlgItem(IDC_CHECK_NO_RESPONSE))->SetCheck(FALSE);
		switch(dwStatusType)
		{
			case EPS_STATUS_INDEX_GENERAL:
				((CButton*)GetDlgItem(IDC_CHECK_OFFLINE))->SetCheck(dwStatus & ESCMC_ASB_OFFLINE);
				((CButton*)GetDlgItem(IDC_CHECK_PAPER_FEED))->SetCheck(dwStatus & ESCMC_ASB_PAPER_FEED);
				((CButton*)GetDlgItem(IDC_CHECK_PAPER_SET))->SetCheck(dwStatus & ESCMC_ASB_PAPER_SET);
				((CButton*)GetDlgItem(IDC_CHECK_COVER_STATUS))->SetCheck(dwStatus & ESCMC_ASB_COVER_STATUS);
				break;
			case EPS_STATUS_INDEX_RETURNNABLE_ERROR:
				((CButton*)GetDlgItem(IDC_CHECK_NO_PAPER))->SetCheck(dwStatus & ESCMC_ASB_NO_PAPER);
				((CButton*)GetDlgItem(IDC_CHECK_PAPER_EJECT))->SetCheck(dwStatus & ESCMC_ASB_PAPER_EJECT);
				((CButton*)GetDlgItem(IDC_CHECK_COVER_OPEN))->SetCheck(dwStatus & ESCMC_ASB_COVER_OPEN);
				break;
			case EPS_STATUS_INDEX_UNRETURNABLE_ERROR:
				((CButton*)GetDlgItem(IDC_CHECK_FATAL_ERROR))->SetCheck(dwStatus & ESCMC_ASB_FATAL_ERROR);
				break;
			case EPS_STATUS_INDEX_AUTO_CARRIAGE_RETURN_ERROR:
				((CButton*)GetDlgItem(IDC_CHECK_HEAD_HOT_ERROR))->SetCheck(dwStatus & ESCMC_ASB_HEAD_HOT_ERROR);
				break;
			default:
				break;
		}
	}
}

// Populate check boxes in Status area
void CSampleProgramDlg::GetDeviceStatus(void)
{
	EPBS_UINT32 dwStatuses[4];
	EPBS_UINT32 dwStatusType = EPS_STATUS_INDEX_GENERAL;
	memset(&dwStatuses, 0, sizeof(EPBS_UINT32) * 4);

	m_api.GetStatus(4, dwStatuses);

	for(int nCount = 0; nCount < 4; nCount++)
	{
		switch(nCount)
		{
			case 0:
				dwStatusType = EPS_STATUS_INDEX_GENERAL;
				break;
			case 1:
				dwStatusType = EPS_STATUS_INDEX_RETURNNABLE_ERROR;
				break;
			case 2:
				dwStatusType = EPS_STATUS_INDEX_UNRETURNABLE_ERROR;
				break;
			case 3:
				dwStatusType = EPS_STATUS_INDEX_AUTO_CARRIAGE_RETURN_ERROR;
				break;
			default:
				break;
		}
		SetDeviceStatus(dwStatusType ,dwStatuses[nCount]);
	}
}

// Enable/Disable buttons
void CSampleProgramDlg::EnableButton(BOOL bEnable)
{
	((CButton*)GetDlgItem(IDC_BUTTON_MICR_READ))->EnableWindow(bEnable);
	((CButton*)GetDlgItem(IDC_BUTTON_MS_READ))->EnableWindow(bEnable);
	((CButton*)GetDlgItem(IDC_BUTTON_MS_WRITE))->EnableWindow(bEnable);
	((CButton*)GetDlgItem(IDC_BUTTON_MS_CLEAR))->EnableWindow(bEnable);
}

// Enable/Disable IBM Data Type radio button
void CSampleProgramDlg::EnableIBMDataType(BOOL bEnable)
{
	((CButton*)GetDlgItem(IDC_RADIO_3C))->EnableWindow(bEnable);
	((CButton*)GetDlgItem(IDC_RADIO_3F))->EnableWindow(bEnable);
	((CStatic*)GetDlgItem(IDC_GROUP_IBMDATATYPE))->EnableWindow(bEnable);
}

// Retrieve a value from the Format combo box
EPBS_UINT32 CSampleProgramDlg::GetFormat(void)
{
	EPBS_UINT32 dwFormat = 0;
	switch(((CComboBox*)GetDlgItem(IDC_COMBO_FORMAT))->GetCurSel())
	{
		case 0:
			dwFormat = EPS_BI_MSRW_FORMAT_IBM3604;
			break;
		case 1:
			dwFormat = EPS_BI_MSRW_FORMAT_DINISO;
			break;
		case 2:
			dwFormat = EPS_BI_MSRW_FORMAT_ANSI;
			break;
		case 3:
			dwFormat = EPS_BI_MSRW_FORMAT_IBM4746;
			break;
		case 4:
			dwFormat = EPS_BI_MSRW_FORMAT_ISO7811;
			break;
		case 5:
			dwFormat = EPS_BI_MSRW_FORMAT_HT2751CIZ;
			break;
		case 6:
			dwFormat = EPS_BI_MSRW_FORMAT_ISO8484;
			break;
		default:
			dwFormat = EPS_BI_MSRW_FORMAT_IBM3604;
			break;
	}
	return dwFormat;
}

// Validate data entry in Write text box
bool CSampleProgramDlg::CheckWriteString(LPCSTR lpcWriteString)
{
	int nLength = (int)strlen(lpcWriteString);

	// Check if field is blank
	if(nLength == 0){
		MessageBox(_T("Text specified to be written to magnetic stripe is empty."), DIALOG_CAPTION, MB_OK | MB_ICONWARNING);
		return true;
	}

	// Check if entered characters are valid
	for(int nCount = 0; nCount < nLength; nCount++)
	{
		if(lpcWriteString[nCount] < 0x30 || lpcWriteString[nCount] > 0x3f)
		{
			MessageBox(_T("Text specified to be written to magnetic stripe is invalid."), DIALOG_CAPTION, MB_OK | MB_ICONWARNING);
			return true;
		}
	}

	// Check if the number of characters does not exceed the limitation
	if(nLength > 105){
		MessageBox(_T("Too many characters specified for text to write to magnetic stripe.\nText length must be less than or equal to 105 characters."), DIALOG_CAPTION, MB_OK | MB_ICONWARNING);
		return true;
	}

	return false;
}
