#include "stdafx.h"
#include "resource.h"
#include "SettingsDlg.h"

#define MAX_MICRENABLETYPE					2
#define MAX_MICRFONTTYPE					2
#define MAX_MICRMETHODTYPE					2

#define MAX_OCRSIDETYPE						2
#define MAX_OCRENABLETYPE					2
#define MAX_OCRABFONTTYPE					12
#define MAX_OCRABDIRECTIONTYPE				4
#define MAX_OCRABSPACEHANDLINGTYPE			2

#define	MAX_BARCODEENABLETYPE				2
#define MAX_BARCODESEARCHMODETYPE			3
#define MAX_ICAP_BARCODESEARCHPRIORITIES	8

TABLEENTRY MICREnable[MAX_MICRENABLETYPE] =
{
	{"Enable", 1},
	{"Disable", 0}
};

TABLEENTRY MICRFont[MAX_MICRFONTTYPE] =
{
	{"E13B", TWEPCS_MF_E13B, },
	{"CMC7", TWEPCS_MF_CMC7, }
};

TABLEENTRY MICROption[MAX_MICRMETHODTYPE] =
{
	{"MICR Only",	TWEPCS_MM_MICRONLY},
	{"MICR and OCR",TWEPCS_MM_MICRANDOCR}
};

TABLEENTRY OCRSide[MAX_OCRSIDETYPE] =
{
	{"FRONT",		TWEPCS_OS_FRONT},
	{"BACKSIDE",	TWEPCS_OS_BACK}
};

TABLEENTRY OCREnable[MAX_OCRENABLETYPE] =
{
	{"Enable",	1},
	{"Disable", 0}
};



TABLEENTRY OCRABFont[MAX_OCRABFONTTYPE] =
{
	{"OCRA_NUM",				TWEPCS_OF_OCR_FONT_OCRA_NUM},
	{"OCRA_ALPHA",				TWEPCS_OF_OCR_FONT_OCRA_ALPHA},
	{"OCRA_ALPHANUM",			TWEPCS_OF_OCR_FONT_OCRA_ALPHANUM},
	{"OCRA_ALPHANUM_WOOH",		TWEPCS_OF_OCR_FONT_OCRA_ALPHANUM_WOOH},
	{"OCRA_ALPHANUM_WOZERO",	TWEPCS_OF_OCR_FONT_OCRA_ALPHANUM_WOZERO},
	{"OCRA_SYMNUM",				TWEPCS_OF_OCR_FONT_OCRA_SYMNUM},
	{"OCRB_NUM",				TWEPCS_OF_OCR_FONT_OCRB_NUM},
	{"OCRB_ALPHA",				TWEPCS_OF_OCR_FONT_OCRB_ALPHA},
	{"OCRB_ALPHANUM",			TWEPCS_OF_OCR_FONT_OCRB_ALPHANUM},
	{"OCRB_ALPHANUM_WOOH",		TWEPCS_OF_OCR_FONT_OCRB_ALPHANUM_WOOH},
	{"OCRB_ALPHANUM_WOZERO",	TWEPCS_OF_OCR_FONT_OCRB_ALPHANUM_WOZERO},
	{"OCRB_SYMNUM",				TWEPCS_OF_OCR_FONT_OCRB_SYMNUM},
};

TABLEENTRY OCRABDirection[MAX_OCRABDIRECTIONTYPE] =
{
	{"From left to right",		TWEPCS_OD_LEFTRIGHT},
	{"From top to bottom",		TWEPCS_OD_TOPBOTTOM},
	{"From right to left",		TWEPCS_OD_RIGHTLEFT},
	{"From bottom to top",		TWEPCS_OD_BOTTOMTOP}
};

TABLEENTRY OCRABSpaceHandling[MAX_OCRABSPACEHANDLINGTYPE] =
{
	{"Enable",		TWEPCS_SH_SPACEENABLE},
	{"Disable",		TWEPCS_SH_SPACEDISABLE}
};

TABLEENTRY BarcodeEnable[MAX_BARCODEENABLETYPE] =
{
	{"Enable",		1},
	{"Disable",		0}
};

TABLEENTRY BarCodeSearchModeType[MAX_BARCODESEARCHMODETYPE] =
{
	{"TWBD_HORZ",		TWBD_HORZ},
	{"TWBD_VERT",		TWBD_VERT},
	{"TWBD_HORZVERT",	TWBD_HORZVERT},
};

UITABLEENTRY BarCodeSearchPriority[MAX_ICAP_BARCODESEARCHPRIORITIES] =
{
	{ IDC_CHECK_BARCODE_CODE39,		TWBT_3OF9 },
	{ IDC_CHECK_BARCODE_ITF,		TWBT_2OF5INTERLEAVED },
	{ IDC_CHECK_BARCODE_CODE128,	TWBT_CODE128 },
	{ IDC_CHECK_BARCODE_CODABAR,	TWBT_CODABAR },
	{ IDC_CHECK_BARCODE_UPCA,		TWBT_UPCA },
	{ IDC_CHECK_BARCODE_UPCE,		TWBT_UPCE },
	{ IDC_CHECK_BARCODE_EAN8,		TWBT_EAN8 },
	{ IDC_CHECK_BARCODE_EAN13,		TWBT_EAN13 }
};

SettingsDlg::SettingsDlg(TwainInterface *pTwainInterface)
{
	m_hDlg					= NULL;
	m_pCapabilityInterface	= new CapabilityInterface(pTwainInterface);
}

SettingsDlg::~SettingsDlg()
{
	if(m_pCapabilityInterface)
	{
		delete m_pCapabilityInterface;
		m_pCapabilityInterface = NULL;
	}
}

//========================================================================
INT_PTR CALLBACK SettingsDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	SettingsDlg	*pSettingsDlg	= NULL;
	INT_PTR		nRet			= FALSE;

	if(!pSettingsDlg)
	{
		pSettingsDlg = (SettingsDlg *)(LONG_PTR)::GetWindowLongPtr(hDlg, DWLP_USER);
	}

	UNREFERENCED_PARAMETER(lParam);
	switch(message)
	{
		case WM_INITDIALOG:
			if(!pSettingsDlg)
			{
				pSettingsDlg = (SettingsDlg *)lParam;
				SetWindowLongPtr(hDlg, DWLP_USER, (LONG)(LONG_PTR)pSettingsDlg);
				nRet = pSettingsDlg->OnInitDialog(hDlg);
			}
			break;

		case WM_COMMAND:
			if(LOWORD(wParam) == IDOK)
			{
				//MSG_SET
				pSettingsDlg->SendSettingsToDataSource();
				EndDialog(hDlg, IDOK);
				nRet = TRUE;
				//}
			}
			else if(LOWORD(wParam) == IDCANCEL)
			{
				//Cancel
				EndDialog(hDlg, IDOK);
				nRet = TRUE;
			}

			break;
	}

	return nRet;
}

//========================================================================
BOOL SettingsDlg::OnInitDialog(HWND hDlg)
{
	if(hDlg == NULL)
	{
		return FALSE;
	}

	m_hDlg = hDlg;

	// Create Menu and Control
	for(TW_UINT32 i = 0; i < MAX_MICRENABLETYPE; i++)
	{
		SendDlgItemMessage(hDlg, IDC_COMBO_MICR_ENABLE, CB_INSERTSTRING, (WPARAM)-1, (LPARAM)MICREnable[i].pszItemName);
		SendDlgItemMessage(hDlg, IDC_COMBO_MICR_ENABLE, CB_SETITEMDATA, 0, (LPARAM)MICREnable[i].ItemId);
	}

	for(TW_UINT32 i = 0; i < MAX_MICRFONTTYPE; i++)
	{
		SendDlgItemMessage(hDlg, IDC_COMBO_MICR_FONT, CB_INSERTSTRING, (WPARAM)-1, (LPARAM)MICRFont[i].pszItemName);
		SendDlgItemMessage(hDlg, IDC_COMBO_MICR_FONT, CB_SETITEMDATA, 0, (LPARAM)MICRFont[i].ItemId);
	}

	for(TW_UINT32 i = 0; i < MAX_MICRMETHODTYPE; i++)
	{
		SendDlgItemMessage(hDlg, IDC_COMBO_MICR_OPTION, CB_INSERTSTRING, (WPARAM)-1, (LPARAM)MICROption[i].pszItemName);
		SendDlgItemMessage(hDlg, IDC_COMBO_MICR_OPTION, CB_SETITEMDATA, 0, (LPARAM)MICROption[i].ItemId);
	}

	//OCRAB
	for(TW_UINT32 i = 0; i < MAX_OCRSIDETYPE; i++)
	{
		SendDlgItemMessage(hDlg, IDC_COMBO_OCR_SIDE, CB_INSERTSTRING, (WPARAM)-1, (LPARAM)OCRSide[i].pszItemName);
		SendDlgItemMessage(hDlg, IDC_COMBO_OCR_SIDE, CB_SETITEMDATA, 0, (LPARAM)OCRSide[i].ItemId);
	}

	for(TW_UINT32 i = 0; i < MAX_OCRENABLETYPE; i++)
	{
		SendDlgItemMessage(hDlg, IDC_COMBO_OCR_ENABLE, CB_INSERTSTRING, (WPARAM)-1, (LPARAM)OCREnable[i].pszItemName);
		SendDlgItemMessage(hDlg, IDC_COMBO_OCR_ENABLE, CB_SETITEMDATA, 0, (LPARAM)OCREnable[i].ItemId);
	}

	for(TW_UINT32 i = 0; i < MAX_OCRABFONTTYPE; i++)
	{
		SendDlgItemMessage(hDlg, IDC_COMBO_OCR_FONT, CB_INSERTSTRING, (WPARAM)-1, (LPARAM)OCRABFont[i].pszItemName);
		SendDlgItemMessage(hDlg, IDC_COMBO_OCR_FONT, CB_SETITEMDATA, 0, (LPARAM)OCRABFont[i].ItemId);
	}

	for(TW_UINT32 i = 0; i < MAX_OCRABDIRECTIONTYPE; i++)
	{
		SendDlgItemMessage(hDlg, IDC_COMBO_OCR_DIRECTION, CB_INSERTSTRING, (WPARAM)-1, (LPARAM)OCRABDirection[i].pszItemName);
		SendDlgItemMessage(hDlg, IDC_COMBO_OCR_DIRECTION, CB_SETITEMDATA, 0, (LPARAM)OCRABDirection[i].ItemId);
	}

	for(TW_UINT32 i = 0; i < MAX_OCRABSPACEHANDLINGTYPE; i++)
	{
		SendDlgItemMessage(hDlg, IDC_COMBO_OCR_SPACEHANDLING, CB_INSERTSTRING, (WPARAM)-1, (LPARAM)OCRABSpaceHandling[i].pszItemName);
		SendDlgItemMessage(hDlg, IDC_COMBO_OCR_SPACEHANDLING, CB_SETITEMDATA, 0, (LPARAM)OCRABSpaceHandling[i].ItemId);
	}

	//Barcode
	for(TW_UINT32 i = 0; i < MAX_BARCODEENABLETYPE; i++)
	{
		SendDlgItemMessage(hDlg, IDC_COMBO_BARCODE_ENABLE, CB_INSERTSTRING, (WPARAM)-1, (LPARAM)BarcodeEnable[i].pszItemName);
		SendDlgItemMessage(hDlg, IDC_COMBO_BARCODE_ENABLE, CB_SETITEMDATA, 0, (LPARAM)BarcodeEnable[i].ItemId);
	}

	for(TW_UINT32 i = 0; i < MAX_BARCODESEARCHMODETYPE; i++)
	{
		SendDlgItemMessage(hDlg, IDC_COMBO_BARCODE_SEARCHMODE, CB_INSERTSTRING, (WPARAM)-1, (LPARAM)BarCodeSearchModeType[i].pszItemName);
		SendDlgItemMessage(hDlg, IDC_COMBO_BARCODE_SEARCHMODE, CB_SETITEMDATA, 0, (LPARAM)BarCodeSearchModeType[i].ItemId);
	}

	RefreshByCurrentValue();

	return TRUE;
}

//========================================================================
void SettingsDlg::RefreshByCurrentValue(void)
{

	GetMicrSettings();
	GetOcrSettings();
	GetBarcodeSettings();

}

//========================================================================
void SettingsDlg::GetMicrSettings()
{
	TW_UINT32	value;
	BOOL		rc;

	//CAP_MICRENABLED
	if(TRUE == (rc = m_pCapabilityInterface->GetValue(CAP_MICRENABLED, &value)))
	{
		for(TW_UINT32 i = 0; i < MAX_MICRENABLETYPE; i++)
		{
			if(MICREnable[i].ItemId == value)
			{
				SendDlgItemMessage(m_hDlg, IDC_COMBO_MICR_ENABLE, CB_SETCURSEL, (WPARAM)i, 0);
				break;
			}
		}
	}
	EnableWindow(GetDlgItem(m_hDlg, IDC_COMBO_MICR_ENABLE), rc);

	// IDC_COMBO_MICR_FONT
	if(TRUE == (rc = m_pCapabilityInterface->GetValue(ICAP_EPCS_MICRFONT, &value)))
	{
		for(TW_UINT32 i = 0; i < MAX_MICRFONTTYPE; i++)
		{
			if(MICRFont[i].ItemId == value)
			{
				SendDlgItemMessage(m_hDlg, IDC_COMBO_MICR_FONT, CB_SETCURSEL, (WPARAM)i, 0);
				break;
			}
		}
	}
	EnableWindow(GetDlgItem(m_hDlg, IDC_COMBO_MICR_FONT), rc);

	// ICAP_EPCS_MICRMETHOD
	if(TRUE == (rc = m_pCapabilityInterface->GetValue(ICAP_EPCS_MICRMETHOD, &value)))
	{
		for(TW_UINT32 i = 0; i < MAX_MICRMETHODTYPE; i++)
		{
			if(MICROption[i].ItemId == value)
			{
				SendDlgItemMessage(m_hDlg, IDC_COMBO_MICR_OPTION, CB_SETCURSEL, (WPARAM)i, 0);
				break;
			}
		}
	}
	EnableWindow(GetDlgItem(m_hDlg, IDC_COMBO_MICR_OPTION), rc);
}

//========================================================================
void SettingsDlg::GetOcrSettings()
{
	TW_UINT32	value;
	BOOL		rc;

	// OCRAB Side
	if(TRUE == (rc = m_pCapabilityInterface->GetValue(ICAP_EPCS_OCRABSIDE, &value)))
	{
		for(TW_UINT32 i = 0; i < MAX_OCRSIDETYPE; i++)
		{
			if(OCRSide[i].ItemId == value)
			{
				SendDlgItemMessage(m_hDlg, IDC_COMBO_OCR_SIDE, CB_SETCURSEL, (WPARAM)i, 0);
				break;
			}
		}
	}
	EnableWindow(GetDlgItem(m_hDlg, IDC_COMBO_OCR_SIDE), rc);

	//OCRAB Enable
	if(TRUE == (rc = m_pCapabilityInterface->GetValue(ICAP_EPCS_OCRABENABLED, &value)))
	{
		for(TW_UINT32 i = 0; i < MAX_OCRENABLETYPE; i++)
		{
			if(OCREnable[i].ItemId == value)
			{
				SendDlgItemMessage(m_hDlg, IDC_COMBO_OCR_ENABLE, CB_SETCURSEL, (WPARAM)i, 0);
				break;
			}
		}
	}
	EnableWindow(GetDlgItem(m_hDlg, IDC_COMBO_OCR_ENABLE), rc);


	//OCRAB
	if(TRUE == (rc = m_pCapabilityInterface->GetValue(ICAP_EPCS_OCRABFONT, &value)))
	{
		for(TW_UINT32 i = 0; i < MAX_OCRABFONTTYPE; i++)
		{
			if(OCRABFont[i].ItemId == value)
			{
				SendDlgItemMessage(m_hDlg, IDC_COMBO_OCR_FONT, CB_SETCURSEL, (WPARAM)i, 0);
				break;
			}
		}
	}
	EnableWindow(GetDlgItem(m_hDlg, IDC_COMBO_OCR_FONT), rc);

	// OCRABDIRECTION
	if(TRUE == (rc = m_pCapabilityInterface->GetValue(ICAP_EPCS_OCRABDIRECTION, &value)))
	{
		for(TW_UINT32 i = 0; i < MAX_OCRABDIRECTIONTYPE; i++)
		{
			if(OCRABDirection[i].ItemId == value)
			{
				SendDlgItemMessage(m_hDlg, IDC_COMBO_OCR_DIRECTION, CB_SETCURSEL, (WPARAM)i, 0);
				break;
			}
		}
	}
	EnableWindow(GetDlgItem(m_hDlg, IDC_COMBO_OCR_DIRECTION), rc);

	// OCRABSPACEHANDLING
	if(TRUE == (rc = m_pCapabilityInterface->GetValue(ICAP_EPCS_OCRABSPACEHANDLING, &value)))
	{
		for(TW_UINT32 i = 0; i < MAX_OCRABSPACEHANDLINGTYPE; i++)
		{
			if(OCRABSpaceHandling[i].ItemId == value)
			{
				SendDlgItemMessage(m_hDlg, IDC_COMBO_OCR_SPACEHANDLING, CB_SETCURSEL, (WPARAM)i, 0);
				break;
			}
		}
	}
	EnableWindow(GetDlgItem(m_hDlg, IDC_COMBO_OCR_SPACEHANDLING), rc);

	// OCRABFRAME Position
	//
	TW_FRAME	twFrame;
	if(TRUE == (rc = m_pCapabilityInterface->GetFrame(ICAP_EPCS_OCRABFRAME, &twFrame)))
	{
		// Position Settings
		char	valuStr[_MAX_PATH];

		// Left
		sprintf_s(valuStr, _countof(valuStr), "%.2f", FIX32ToFloat(twFrame.Left) );
		SetWindowText(GetDlgItem(m_hDlg,IDC_EDIT_LEFT), valuStr);
		
		// Top
		sprintf_s(valuStr, _countof(valuStr), "%.2f", FIX32ToFloat(twFrame.Top));
		SetWindowText(GetDlgItem(m_hDlg,IDC_EDIT_TOP), valuStr);

		// Right
		sprintf_s(valuStr, _countof(valuStr), "%.2f", FIX32ToFloat(twFrame.Right));
		SetWindowText(GetDlgItem(m_hDlg,IDC_EDIT_RIGHT), valuStr);

		// Bottom
		sprintf_s(valuStr, _countof(valuStr), "%.2f", FIX32ToFloat(twFrame.Bottom));
		SetWindowText(GetDlgItem(m_hDlg,IDC_EDIT_BOTTOM), valuStr);

	}
	EnableWindow(GetDlgItem(m_hDlg, IDC_EDIT_LEFT), rc);
	EnableWindow(GetDlgItem(m_hDlg, IDC_EDIT_BOTTOM), rc);
	EnableWindow(GetDlgItem(m_hDlg, IDC_EDIT_TOP), rc);
	EnableWindow(GetDlgItem(m_hDlg, IDC_EDIT_RIGHT), rc);

}

//========================================================================
void SettingsDlg::GetBarcodeSettings()
{
	TW_UINT32	value;
	BOOL		rc;

	//Barcode Enable
	if(TRUE == (rc = m_pCapabilityInterface->GetValue(ICAP_BARCODEDETECTIONENABLED, &value)))
	{
		for(TW_UINT32 i = 0; i < MAX_BARCODEENABLETYPE; i++)
		{
			if(OCREnable[i].ItemId == value)
			{
				SendDlgItemMessage(m_hDlg, IDC_COMBO_BARCODE_ENABLE, CB_SETCURSEL, (WPARAM)i, 0);
				break;
			}
		}
	}
	EnableWindow(GetDlgItem(m_hDlg, IDC_COMBO_BARCODE_ENABLE), rc);

	//Barcode Search Direction
	if(TRUE == (rc = m_pCapabilityInterface->GetValue(ICAP_BARCODESEARCHMODE, &value)))
	{
		for(TW_UINT32 i = 0; i < MAX_BARCODESEARCHMODETYPE; i++)
		{
			if(BarCodeSearchModeType[i].ItemId == value)
			{
				SendDlgItemMessage(m_hDlg, IDC_COMBO_BARCODE_SEARCHMODE, CB_SETCURSEL, (WPARAM)i, 0);
				break;
			}
		}
	}
	EnableWindow(GetDlgItem(m_hDlg, IDC_COMBO_BARCODE_SEARCHMODE), rc);

	//Barcode Search Priorityes

	TW_UINT16 valueList[MAX_ICAP_BARCODESEARCHPRIORITIES];
	TW_UINT32 count = MAX_ICAP_BARCODESEARCHPRIORITIES;

	memset(&valueList, 0, sizeof(TW_UINT16) * MAX_ICAP_BARCODESEARCHPRIORITIES);
	if(TRUE == (rc = m_pCapabilityInterface->GetCapArray(ICAP_BARCODESEARCHPRIORITIES, TWTY_UINT16, valueList, &count)))
	{
		for(TW_UINT32 i = 0; i < MAX_ICAP_BARCODESEARCHPRIORITIES; i++)
		{
			BOOL	bEnable = FALSE;
			for(TW_UINT32 l = 0 ; l < count ; l++)
			{
				if(BarCodeSearchPriority[i].ItemId == valueList[l])
				{
					bEnable = TRUE;
					break;
				}
			}
			CheckDlgButton(m_hDlg, BarCodeSearchPriority[i].controlID, bEnable);
		}
	}
	else
	{
		for(TW_UINT32 i = 0 ; i < MAX_ICAP_BARCODESEARCHPRIORITIES ; i++)
		{
			CheckDlgButton(m_hDlg, BarCodeSearchPriority[i].controlID, 0);
			EnableWindow(GetDlgItem(m_hDlg, BarCodeSearchPriority[i].controlID), false);
		}
	}
}
//========================================================================
void SettingsDlg::SetScanSettings(void)
{
	    TW_UINT32       item = TWEPCS_DO_LOWERFIRST;

        m_pCapabilityInterface->SetOneValue(CAP_EPCS_DUPLEXORDER, TWTY_UINT16, (const pTW_UINT32)&item);
}

//========================================================================
void SettingsDlg::SetMicrSettings(void)
{
	LONG_PTR lIndex = 0;

	// MICR Enable
	if(IsWindowEnabled(GetDlgItem(m_hDlg, IDC_COMBO_MICR_ENABLE)))
	{
		lIndex = SendDlgItemMessage(m_hDlg, IDC_COMBO_MICR_ENABLE, CB_GETCURSEL, (WPARAM)0, (LPARAM)0);
		m_pCapabilityInterface->SetOneValue(CAP_MICRENABLED, TWTY_BOOL, (const pTW_UINT32)&MICREnable[lIndex].ItemId);
	}

	// MICR Font
	if(IsWindowEnabled(GetDlgItem(m_hDlg, IDC_COMBO_MICR_FONT)))
	{
		lIndex = SendDlgItemMessage(m_hDlg, IDC_COMBO_MICR_FONT, CB_GETCURSEL, (WPARAM)0, (LPARAM)0);
		m_pCapabilityInterface->SetOneValue(ICAP_EPCS_MICRFONT, TWTY_UINT16, (const pTW_UINT32)&MICRFont[lIndex].ItemId);
	}

	// MICR Options
	if(IsWindowEnabled(GetDlgItem(m_hDlg, IDC_COMBO_MICR_FONT)))
	{
		lIndex = SendDlgItemMessage(m_hDlg, IDC_COMBO_MICR_OPTION, CB_GETCURSEL, (WPARAM)0, (LPARAM)0);
		m_pCapabilityInterface->SetOneValue(ICAP_EPCS_MICRMETHOD, TWTY_UINT16, (const pTW_UINT32)&MICROption[lIndex].ItemId);
	}

}

//========================================================================
void SettingsDlg::SetOcrSettings(void)
{
	LONG_PTR lIndex = 0;
	
	// OCR Side
	if(IsWindowEnabled(GetDlgItem(m_hDlg, IDC_COMBO_OCR_SIDE)))
	{
		lIndex = SendDlgItemMessage(m_hDlg, IDC_COMBO_OCR_SIDE, CB_GETCURSEL, (WPARAM)0, (LPARAM)0);
		m_pCapabilityInterface->SetOneValue(ICAP_EPCS_OCRABSIDE, TWTY_UINT16, (const pTW_UINT32)&OCRSide[lIndex].ItemId);
	
	}
	
	// OCR Enable
	if(IsWindowEnabled(GetDlgItem(m_hDlg, IDC_COMBO_OCR_ENABLE)))
	{
		lIndex = SendDlgItemMessage(m_hDlg, IDC_COMBO_OCR_ENABLE, CB_GETCURSEL, (WPARAM)0, (LPARAM)0);
		m_pCapabilityInterface->SetOneValue(ICAP_EPCS_OCRABENABLED, TWTY_BOOL, (const pTW_UINT32)&OCREnable[lIndex].ItemId);
	
	}
	// OCRABFont
	if(IsWindowEnabled(GetDlgItem(m_hDlg, IDC_COMBO_OCR_FONT)))
	{
		lIndex = SendDlgItemMessage(m_hDlg, IDC_COMBO_OCR_FONT, CB_GETCURSEL, (WPARAM)0, (LPARAM)0);
		m_pCapabilityInterface->SetOneValue(ICAP_EPCS_OCRABFONT, TWTY_UINT16, (const pTW_UINT32)&OCRABFont[lIndex].ItemId);
	}
	
	// OCRABDirection
	if(IsWindowEnabled(GetDlgItem(m_hDlg, IDC_COMBO_OCR_DIRECTION)))
	{
		lIndex = SendDlgItemMessage(m_hDlg, IDC_COMBO_OCR_DIRECTION, CB_GETCURSEL, (WPARAM)0, (LPARAM)0);
		m_pCapabilityInterface->SetOneValue(ICAP_EPCS_OCRABDIRECTION, TWTY_UINT16, (const pTW_UINT32)&OCRABDirection[lIndex].ItemId);
	}

	//OCRABSpaceHandling
	if(IsWindowEnabled(GetDlgItem(m_hDlg, IDC_COMBO_OCR_SPACEHANDLING)))
	{
		lIndex = SendDlgItemMessage(m_hDlg, IDC_COMBO_OCR_SPACEHANDLING, CB_GETCURSEL, (WPARAM)0, (LPARAM)0);
		m_pCapabilityInterface->SetOneValue(ICAP_EPCS_OCRABSPACEHANDLING, TWTY_UINT16, (const pTW_UINT32)&OCRABSpaceHandling[lIndex].ItemId);
	}

	//OCRFrame
	if(IsWindowEnabled(GetDlgItem(m_hDlg, IDC_EDIT_LEFT)) && 
		IsWindowEnabled(GetDlgItem(m_hDlg, IDC_EDIT_BOTTOM)) &&
		  IsWindowEnabled(GetDlgItem(m_hDlg, IDC_EDIT_TOP)) &&
		    IsWindowEnabled(GetDlgItem(m_hDlg, IDC_EDIT_RIGHT)) )
	{
		float		fValue;
		TW_FRAME	twFrame;

		// Position Settings
		char	valuStr[_MAX_PATH];
		
		//Left 
		GetWindowText(GetDlgItem(m_hDlg,IDC_EDIT_LEFT), valuStr, sizeof(valuStr));
		sscanf_s(valuStr, "%f", &fValue);
		twFrame.Left = FloatToFIX32(fValue);
		
		//Top
		GetWindowText(GetDlgItem(m_hDlg,IDC_EDIT_TOP), valuStr, sizeof(valuStr));
		sscanf_s(valuStr, "%f",&fValue);
		twFrame.Top = FloatToFIX32(fValue);

		//Right
		GetWindowText(GetDlgItem(m_hDlg,IDC_EDIT_RIGHT), valuStr, sizeof(valuStr));
		sscanf_s(valuStr, "%f",&fValue);
		twFrame.Right = FloatToFIX32(fValue);

		//Bottom
		GetWindowText(GetDlgItem(m_hDlg,IDC_EDIT_BOTTOM), valuStr, sizeof(valuStr));
		sscanf_s(valuStr, "%f",&fValue);
		twFrame.Bottom = FloatToFIX32(fValue);
		
		m_pCapabilityInterface->SetFrame(ICAP_EPCS_OCRABFRAME, (const TW_FRAME *)&twFrame);
	}
	
}

//========================================================================
void SettingsDlg::SetBarcodeSettings(void)
{
	LONG_PTR lIndex = 0;

	//Barcode Enable
	if(IsWindowEnabled(GetDlgItem(m_hDlg, IDC_COMBO_BARCODE_ENABLE)))
	{
		lIndex = SendDlgItemMessage(m_hDlg, IDC_COMBO_BARCODE_ENABLE, CB_GETCURSEL, (WPARAM)0, (LPARAM)0);
		m_pCapabilityInterface->SetOneValue(ICAP_BARCODEDETECTIONENABLED, TWTY_BOOL, (const pTW_UINT32)&BarcodeEnable[lIndex].ItemId);
	}

	//Barcode Search Direction
	if(IsWindowEnabled(GetDlgItem(m_hDlg, IDC_COMBO_BARCODE_SEARCHMODE)))
	{
		lIndex = SendDlgItemMessage(m_hDlg, IDC_COMBO_BARCODE_SEARCHMODE, CB_GETCURSEL, (WPARAM)0, (LPARAM)0);
		m_pCapabilityInterface->SetOneValue(ICAP_BARCODESEARCHMODE, TWTY_UINT16, (const pTW_UINT32)&BarCodeSearchModeType[lIndex].ItemId);
	}
	
	//Barcode Search Priorityes
	TW_UINT16 valueList[MAX_ICAP_BARCODESEARCHPRIORITIES];
	TW_UINT32	  count = 0;
	for(TW_UINT32 i = 0 ; i < MAX_ICAP_BARCODESEARCHPRIORITIES ; i++)
	{
		if(IsDlgButtonChecked(m_hDlg, BarCodeSearchPriority[i].controlID))
		{
			valueList[count] =  BarCodeSearchPriority[i].ItemId;
			count++;
		}
	}
	if( count > 0)
		m_pCapabilityInterface->SetCapArray(ICAP_BARCODESEARCHPRIORITIES, TWTY_UINT16, (const void*)&valueList, count);

}

//========================================================================
void SettingsDlg::SendSettingsToDataSource()
{

	SetScanSettings();
	SetMicrSettings();
	SetOcrSettings();
	SetBarcodeSettings();

}


//========================================================================
float SettingsDlg::FIX32ToFloat(TW_FIX32 fix32)
{
	float   fValue = 0;

	fValue = (float) fix32.Whole + (float)(fix32.Frac / 65536.0);
	return(fValue);
}

//========================================================================
TW_FIX32 SettingsDlg::FloatToFIX32(float fValue)
{
	TW_FIX32 fix32;
	TW_BOOL sign = (fValue < 0)?TRUE:FALSE;
	TW_INT32 value = (TW_INT32)(fValue * 65536.0 + (sign?(-0.5):0.5));

	memset(&fix32, 0, sizeof(TW_FIX32));

	fix32.Whole = LOWORD(value >> 16);
	fix32.Frac = LOWORD(value & 0x0000ffffL);

	return (fix32);
}

