#ifndef __SETTINGS_DLG_H__
#define __SETTINGS_DLG_H__

#include "TwainInterface.h"
#include "CapabilityInterface.h"
#include "SampleDlg.h"
#include "SampleApp.h"

typedef struct
{
	const char *pszItemName;
	TW_UINT16	ItemId;
} TABLEENTRY, *pTABLEENTRY;

typedef struct
{
	short		controlID;
	TW_UINT16	ItemId;
} UITABLEENTRY, *pUITABLEENTRY;

INT_PTR CALLBACK SettingsDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

class SettingsDlg
{
public:
	SettingsDlg(TwainInterface	*pTwainInterface);
	virtual ~SettingsDlg(void);

	BOOL	OnInitDialog				(HWND hDlg);
	void	SendSettingsToDataSource	(void);
	void	OnCommand					(HWND hDlg, WPARAM wParam, LPARAM lParam);
	BOOL	ChangeEdit					(HWND hCtrl, WORD wCtrlID, WORD wNotifyCode);

private:
	HWND				m_hDlg;
	CapabilityInterface	*m_pCapabilityInterface;

	void	RefreshByCurrentValue(void);

	void	SetScanSettings(void);

	void	GetMicrSettings(void);
	void	SetMicrSettings(void);

	void	GetOcrSettings(void);
	void	SetOcrSettings(void);

	void	GetBarcodeSettings(void);
	void	SetBarcodeSettings(void);

	float			FIX32ToFloat			(TW_FIX32 fix32);
	TW_FIX32		FloatToFIX32			(float fValue);

};

#endif	// __SETTINGS_DLG_H__